## xen 4.17.5+23-ga4e5191dc0

=== debian/changelog ===
xen (4.17.5+23-ga4e5191dc0-1+deb12u1) bookworm; urgency=medium

  * Ignore lintian error not relevant for bookworm in salsa-ci.
  * Cherry-pick e6472d4668 (tools/xg: increase LZMA_BLOCK_SIZE for
    uncompressing the kernel) to allow direct kernel boot with kernels >=
    6.12 (Closes: #1092495).

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Wed, 19 Feb 2025 00:00:27 +0100

=== debian/control ===
Source: xen
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Ian Jackson <iwj@xenproject.org>, Hans van Kranenburg <hans@knorrie.org>
Section: admin
Standards-Version: 4.6.2
Build-Depends:
   debhelper-compat (= 13),
   dh-exec,
   dpkg-dev (>= 1.16.0~),
   file,
   rdfind,
   lsb-release,
   flex, bison,
   python3-dev:any,
   libpython3-dev,
   dh-python,
   bcc [amd64],
   gcc-multilib [amd64],
   libext2fs-dev,
   iasl,
   seabios (>= 1.7.4-2~) [amd64],
   libaio-dev,
   libfdt-dev [armhf arm64],
   libglib2.0-dev,
   liblzma-dev,
   libncurses-dev,
   libpixman-1-dev,
   libyajl-dev,
   pkg-config,
   uuid-dev,
   zlib1g-dev,
   libzstd-dev,
   pandoc,
   ocaml,
   ocaml-findlib,
Homepage: https://xenproject.org/
Vcs-Browser: https://salsa.debian.org/xen-team/debian-xen
Vcs-Git: https://salsa.debian.org/xen-team/debian-xen.git
Rules-Requires-Root: no

Package: xenstore-utils
Architecture: amd64 arm64 armhf
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Breaks: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Suggests: xen-doc
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See https://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Section: admin
Architecture: amd64 armhf arm64
Depends: sysvinit-utils (>= 3.05-4~) | lsb-base, udev, xenstore-utils,
    ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
# The "| lsb-base" is needed for backporting to bullseye. It can be removed
# once backporting to bullseye is no longer needed.
Suggests: xen-doc
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-hypervisor-common
Section: kernel
Architecture: amd64 armhf arm64
Depends: ${misc:Depends}
Replaces: xen-hypervisor-4.8-amd64, xen-hypervisor-4.8-arm64, xen-hypervisor-4.8-armhf
Description: Xen Hypervisor - common files
 The configuration which arranges for an installed hypervisor to be booted
 as default, with the right command line arguments passed to both
 hypervisor and host (Domain 0) kernel.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-doc
Section: doc
Architecture: amd64 armhf arm64
Depends: ${misc:Depends}
Description: Xen documentation
 Documentation for the Xen hypervisor and surrounding software,
 including descriptions of the hypercall interfaces and of some
 of the library APIs.
 .
 You do not need this package for the primary manpages for the
 Xen control utilities, as those are in the xen-utils-common package.
# Yes, arch-specific.  See xen-doc.lintian-overrides.

Package: xen-utils-4.17
Section: admin
Architecture: amd64 arm64 armhf
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, xen-hypervisor-4.17, qemu-system-xen (>> 1:7.0+dfsg-6~) [amd64], grub-xen-host [amd64]
Suggests: qemu-utils [amd64], seabios [amd64], ovmf
Description: Xen administrative tools
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 qemu-utils and seabios are needed for "Xen HVM" (amd64)
Built-Using: ${misc:Built-Using}

Package: xen-utils-4.17-dbg
Section: debug
Architecture: amd64 arm64 armhf
Priority: optional
Depends: xen-utils-4.17 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for xen-utils-4.17
 This package provides debug symbols for the xen-utils binaries as well as
 detached debug symbols for the `shim' used for booting PV guests in an HVM
 container.

Package: xen-hypervisor-4.17-amd64
Section: kernel
Architecture: amd64
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-amd64-dbg
Section: debug
Architecture: amd64
Priority: optional
Depends: xen-hypervisor-4.17-amd64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on AMD64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-amd64
Section: admin
Architecture: amd64
Provides: xen-system
Depends: xen-hypervisor-4.17-amd64, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on AMD64 (metapackage)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.17-arm64
Section: kernel
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-arm64-dbg
Section: debug
Architecture: arm64
Priority: optional
Depends: xen-hypervisor-4.17-arm64 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on ARM64
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-arm64
Section: admin
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.17-arm64, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on ARM64 (metapackage)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: xen-hypervisor-4.17-armhf
Section: kernel
Architecture: armhf
Provides: xen-hypervisor, xen-hypervisor-4.17, xen-hypervisor-armhf
Depends: ${misc:Depends}
Recommends: xen-utils-4.17, xen-hypervisor-common
Description: Xen Hypervisor on ARMHF
 The hypervisor is the "core" for Xen itself.  It gets started by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.

Package: xen-hypervisor-4.17-armhf-dbg
Section: debug
Architecture: armhf
Priority: optional
Depends: xen-hypervisor-4.17-armhf (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for Xen Hypervisor on ARMHF
 This package provides the detached debug symbols for the Xen hypervisor.

Package: xen-system-armhf
Section: admin
Architecture: armhf
Provides: xen-system
Depends: xen-hypervisor-4.17-armhf, xen-hypervisor-common, xen-utils-4.17, ${misc:Depends}
Description: Xen System on ARMHF (metapackage)
 This package depends on the latest Xen hypervisor for use on ARMHF and the
 Xen utils.

Package: libxen-dev
Section: libdevel
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends},
	 libxenmisc4.17 (= ${binary:Version}),
	 libxencall1 (= ${binary:Version}),
	 libxendevicemodel1 (= ${binary:Version}),
	 libxenevtchn1 (= ${binary:Version}),
	 libxenforeignmemory1 (= ${binary:Version}),
	 libxengnttab1 (= ${binary:Version}),
	 libxenstore4 (= ${binary:Version}),
	 libxentoolcore1 (= ${binary:Version}),
	 libxentoollog1 (= ${binary:Version}),
	 libxenhypfs1 (= ${binary:Version}),
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with
 the XenStore database.  Command line tools for accessing xenstore are
 provided is via the xenstore-utils package.
 .
 Most of the other included libraries are internal, and intended for
 use by the Xen toolstack, rather than directly.

Package: libxenmisc4.17
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - miscellaneous, versioned ABI
 Shared libraries for Xen utilities.
 This package contains libraries whose ABI changes with each
 new upstream Xen release, which include ones which embed
 knowledge of hypervisor-version-specific hypercall ABIs.
Multi-Arch: same

Package: libxencall1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxencall
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxendevicemodel1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxendevicemodel
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenevtchn1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenevtchn
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenforeignmemory1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenforeignmemory
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxengnttab1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxengnttab
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenstore4
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenstore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoolcore1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoolcore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoollog1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoollog
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenhypfs1
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxenhypfs
 Shared library for Xen utilities.
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL    := bash -e

# This gives us DEB_VERSION_UPSTREAM and DEB_VERSION (used by our delta queue)
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION

# DEB_MAINTAINER is used by our delta queue
export DEB_MAINTAINER := $(shell sed -ne 's/^Maintainer: \(.*\)$$/\1/p' debian/control)

# This influences dpkg-buildflags to specify better linker
# options.  See https://wiki.debian.org/Hardening
# Apparently some of these might incur silent breakage
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939560#5
# but we don't think this is relevant to us.
#
# Note that we don't use the dpkg-buildflags output for the
# hypervisor build.  This because I haven't investigated which
# of them are sane to use in the hypervisor context, rather than
# simply in userland binaries.
#
# Inexplicably, if you tell make `export V=value' and `$(shell ...)'
# it does not pass V to the shell.  WTF.  So we set a variable
# dbmo which we include in the relevant $(shell ...) invocations.
dbmo= DEB_BUILD_MAINT_OPTIONS="hardening=+all"

# Architecture handling.
#
# We need to explicitly specify the architecture because the Xen
# upstream build system likes to use `uname' which can produce wrong
# answers in other-bitness chroots.

# Also there is terminological confusion.  The DEB_* variables follow
# GNU GCC terminology:
#
# dpkg / GNU    Xen         Meaning
#  BUILD         COMPILE     Host: where this build is running
#  HOST          TARGET      Target: where the binaries we build now will run

include /usr/share/dpkg/architecture.mk

# Xen has its own different architecture names, which are nither
# Debian nor GNU names.

flavour_amd64 = amd64
flavour_armhf = armhf
flavour_arm64 = arm64

xen_arch_amd64 = x86_64
xen_arch_armhf = arm32
xen_arch_arm64 = arm64

flavour=$(flavour_$(DEB_HOST_ARCH))

# Much of the work here is to make different upstream versions of Xen
# coinstallable, and arrange to run which ever version of the tools
# corresponds to the running hypervisor.
#
# This packaging produces one version.  The nominal upstream version
# represents the control ABI used by hypervisor management utilities.
#
# In this package that version number appears in (i) debian/control
# and (ii) the first two numbers in the package version in
# debian/changelog.  These must both be updated when a new major
# upstream version is packaged (eg 4.10 -> 4.11).
# (Everywhere else, it is handled dynamically.)
#
upstream_version := \
 $(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/\(\.[0-9]*\)\..*/\1/' )

# Many of the debhelper files are most conveniently provided as
# templates which depend on the flavour and the upstream version.
# Since even some package names depend on the version, so do some
# dh input filenames.  We support this as follows:
#
# These runes take all files named   debian/*.vsn-in
# and do these three things:
#  1. in the file contents
#    (a) substitute @version@ @flavour@
#    (b) interpret lines like
#		? flavour = <value> [ | <other-value> ...]
#		? flavour != <value> [ | <other-value> ...]
#     as conditional output lasting until the next ? on is own.
#  2. replace any V in the file *name* with that same version
#     and any F with the flavour
#  3. strip .vsn-in from the end
# The resulting files are then consumed by dh.
#
# (debhelper has a shell script control file facility, but that cannot
# handle the need to vary the actual filename seen by debhelper.)

TEMPLATE_FILES := $(wildcard debian/*.vsn-in)

define template_rule_template =
 TEMPLATED_FILES += $(2)
 $(2): $(1) debian/rules debian/changelog debian/template-subst
	debian/template-subst $(upstream_version) $(flavour) <$$< >$$@.tmp \
	&& mv -f $$@{.tmp,}
endef

$(foreach t,$(TEMPLATE_FILES), $(eval 					\
	$(call 								\
		template_rule_template, $t, 				\
		$(subst F,$(flavour),					\
		 $(subst V,$(upstream_version),				\
		  $(basename $t)					\
		 ))							\
	)))

templated-files: $(TEMPLATED_FILES)
	:

# Work around bug in dpkg-buildpackage: between dpkg 1.14.17 and 1.16.1
# it exports these.  This is a problem because we need to pass different
# options to the hypervisor build - the default options from dpkg
# et al are suitable for dom0 binaries but not for the hypervisor.
undefine CFLAGS
undefine CXXFLAGS
undefine FFLAGS
undefine CPPFLAGS
undefine LDFLAGS

# The Xen build system likes to download things at build-time.  We
# think we have disabled all of that with appropriate configure
# options.  But, set these too, so we spot if we miss any.
export WGET=/bin/false GIT=/bin/false

# Other build flags etc.

t=$(CURDIR)/debian/tmp

dpkg_CFLAGS   := $(shell $(dbmo) dpkg-buildflags --get CFLAGS)
dpkg_CPPFLAGS := $(shell $(dbmo) dpkg-buildflags --get CPPFLAGS)
dpkg_LDFLAGS  := $(shell $(dbmo) dpkg-buildflags --get LDFLAGS)

make_args_common := \
	CC=$(DEB_HOST_GNU_TYPE)-gcc \
	LD=$(DEB_HOST_GNU_TYPE)-ld \
	XEN_COMPILE_ARCH=$(xen_arch_$(DEB_BUILD_ARCH)) \
	V=1

# Passing -ffile-prefix-map is needed for reproducible builds.
# Additionally passing -fdebug-prefix-map in necessary to work around a gcc bug
# where -ffile-prefix-map is ignored with assembly files. See
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93371
make_args_xen := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(flavour)) \
	EXTRA_CFLAGS_XEN_CORE='-ffile-prefix-map=$(shell pwd)=. -fdebug-prefix-map=$(shell pwd)=.'

# (Xen upstream does not offer a separate CPPFLAGS,
# so we pass those in CFLAGS.)
# The BUILD_PATH_PREFIX_MAP is needed for ocaml to reproducibly build
# oxenstored
make_args_tools := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(DEB_HOST_ARCH)) \
	EXTRA_CFLAGS_XEN_TOOLS='$(dpkg_CFLAGS) $(dpkg_CPPFLAGS)' \
	PREPEND_LDFLAGS_XEN_TOOLS='$(dpkg_LDFLAGS)' \
	BUILD_PATH_PREFIX_MAP='.=$(shell pwd)'

# use the date from SOURCE_DATE_EPOCH for reproducible builds
export XEN_BUILD_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)")
export XEN_BUILD_TIME=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%T")
export SMBIOS_REL_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%m/%d/%Y")
export VGABIOS_REL_DATE=$(shell LC_ALL=C date -u -d "@$(SOURCE_DATE_EPOCH)" "+%d %b %Y")


%:
	dh $@ --with=python3

# Without this, something on stretch passes CFLAGS in the environment
# to the Xen build system, which then (with 4.11) chokes printing
#   /bin/sh: 1: Syntax error: Unterminated quoted string
# probably because the CFLAGS value contains multiple options and
# therefore spaces.  See also the note by `undefine CFLAGS', above.
override_dh_auto_clean:
	rm -f debian/xen-tools-built.stamp
	$(MAKE) -j1 distclean

# To avoid that the build dirties the tree, our delta queue deletes
# config.sub and config.guess.  dh_update_autotools_config can get
# us fresh ones for each build, but it expects to find some there
# already with some weird properties.  Instead, just copy them
# from /usr/share/misc (which is where it gets them anyway)
override_dh_update_autotools_config:
	cp /usr/share/misc/{config.sub,config.guess} .

# Upstream has both a kconfig style configure for the hypervisor
# and autoconfery for the tools (what we call the `utils').
override_dh_auto_configure:
	cp debian/xen-kconfig xen/.config
	make -C xen olddefconfig $(make_args_xen)
	:
	$(make_args_tools) ./configure \
		--disable-stubdom \
		--prefix=/usr \
		--includedir=/usr/include \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-libexec-libdir-suffix=/$(DEB_HOST_MULTIARCH) \
		--host=$(DEB_HOST_MULTIARCH) \
		--mandir=/usr/share/man \
		--infodir=/usr/share/info \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-libexec-leaf-dir=xen-$(upstream_version) \
		--disable-blktap1 \
		--disable-blktap2 \
		--disable-qemu-traditional --disable-rombios \
		--with-system-qemu=/usr/libexec/xen-qemu-system-i386 \
		--enable-ovmf --with-system-ovmf=/usr/share/ovmf/OVMF.fd \
		--with-system-seabios=/usr/share/seabios/bios-256k.bin

## xen 4.17.5+72

=== xen/lib/Makefile ===
obj-$(CONFIG_X86) += x86/

lib-y += bsearch.o
lib-y += ctors.o
lib-y += ctype.o
lib-y += list-sort.o
lib-y += memchr.o
lib-y += memchr_inv.o
lib-y += memcmp.o
lib-y += memcpy.o
lib-y += memmove.o
lib-y += memset.o
lib-y += muldiv64.o
lib-y += parse-size.o
lib-y += rbtree.o
lib-$(CONFIG_X86) += sha2-256.o
lib-y += sort.o
lib-y += strcasecmp.o
lib-y += strchr.o
lib-y += strcmp.o
lib-y += strlcat.o
lib-y += strlcpy.o
lib-y += strlen.o
lib-y += strncasecmp.o
lib-y += strncmp.o
lib-y += strnlen.o
lib-y += strpbrk.o
lib-y += strrchr.o
lib-y += strsep.o
lib-y += strspn.o
lib-y += strstr.o
lib-$(CONFIG_X86) += xxhash32.o
lib-$(CONFIG_X86) += xxhash64.o

lib32-y := divmod.o
lib32-$(CONFIG_64BIT) :=
lib-y += $(lib32-y)

=== xen/arch/x86/Makefile ===
obj-y += acpi/
obj-y += boot/
obj-y += cpu/
obj-y += efi/
obj-y += genapic/
obj-$(CONFIG_GUEST) += guest/
obj-$(CONFIG_HVM) += hvm/
obj-y += mm/
obj-$(CONFIG_XENOPROF) += oprofile/
obj-$(CONFIG_PV) += pv/
obj-y += x86_64/

obj-y += alternative.o
obj-y += apic.o
obj-y += bhb-thunk.o
obj-y += bitops.o
obj-bin-y += bzimage.init.o
obj-bin-y += clear_page.o
obj-bin-y += copy_page.o
obj-y += cpu-policy.o
obj-y += cpuid.o
obj-$(CONFIG_PV) += compat.o
obj-$(CONFIG_PV32) += x86_64/compat.o
obj-$(CONFIG_KEXEC) += crash.o
obj-y += delay.o
obj-y += desc.o
obj-bin-y += dmi_scan.init.o
obj-y += domain.o
obj-bin-y += dom0_build.init.o
obj-y += domain_page.o
obj-y += e820.o
obj-y += emul-i8254.o
obj-y += extable.o
obj-y += flushtlb.o
obj-$(CONFIG_CRASH_DEBUG) += gdbstub.o
obj-$(CONFIG_GDBSX) += gdbsx.o
obj-y += hypercall.o
obj-y += i387.o
obj-y += i8259.o
obj-y += io_apic.o
obj-$(CONFIG_LIVEPATCH) += livepatch.o
obj-y += msi.o
obj-y += msr.o
obj-$(CONFIG_INDIRECT_THUNK) += indirect-thunk.o
obj-$(CONFIG_RETURN_THUNK) += indirect-thunk.o
obj-$(CONFIG_PV) += ioport_emulate.o
obj-y += irq.o
obj-$(CONFIG_KEXEC) += machine_kexec.o
obj-y += mm.o x86_64/mm.o
obj-$(CONFIG_HVM) += monitor.o
obj-y += mpparse.o
obj-y += nmi.o
obj-y += numa.o
obj-y += pci.o
obj-y += percpu.o
obj-y += physdev.o
obj-$(CONFIG_COMPAT) += x86_64/physdev.o
obj-y += psr.o
obj-y += setup.o
obj-y += shutdown.o
obj-y += smp.o
obj-y += smpboot.o
obj-y += spec_ctrl.o
obj-y += srat.o
obj-y += string.o
obj-y += time.o
obj-y += traps.o
obj-y += tsx.o
obj-y += usercopy.o
obj-y += x86_emulate.o
obj-$(CONFIG_TBOOT) += tboot.o
obj-y += hpet.o
obj-y += vm_event.o
obj-y += xstate.o

ifneq ($(CONFIG_PV_SHIM_EXCLUSIVE),y)
obj-y += domctl.o
obj-y += platform_hypercall.o
obj-$(CONFIG_COMPAT) += x86_64/platform_hypercall.o
obj-y += sysctl.o
endif

extra-y += asm-macros.i
extra-y += xen.lds

hostprogs-y += boot/mkelf32
hostprogs-y += efi/mkreloc

# Allows usercopy.c to include itself
$(obj)/usercopy.o: CFLAGS-y += -iquote .

ifneq ($(CONFIG_HVM),y)
$(obj)/x86_emulate.o: CFLAGS-y += -Wno-unused-label
endif

efi-y := $(shell if [ ! -r $(objtree)/include/xen/compile.h -o \
                      -O $(objtree)/include/xen/compile.h ]; then \
                         echo '$(TARGET).efi'; fi) \
         $(space)
efi-$(CONFIG_PV_SHIM_EXCLUSIVE) :=

ifneq ($(build_id_linker),)
notes_phdrs = --notes
else
ifeq ($(CONFIG_PVH_GUEST),y)
notes_phdrs = --notes
endif
endif

ifdef CONFIG_LIVEPATCH
all_symbols = --all-symbols
ifdef CONFIG_FAST_SYMBOL_LOOKUP
all_symbols = --all-symbols --sort-by-name
endif
else
all_symbols =
endif

syms-warn-dup-y := --warn-dup
syms-warn-dup-$(CONFIG_SUPPRESS_DUPLICATE_SYMBOL_WARNINGS) :=
syms-warn-dup-$(CONFIG_ENFORCE_UNIQUE_SYMBOLS) := --error-dup

orphan-handling-$(call ld-option,--orphan-handling=warn) += --orphan-handling=warn

$(TARGET): TMP = $(@D)/.$(@F).elf32
$(TARGET): $(TARGET)-syms $(efi-y) $(obj)/boot/mkelf32
	$(obj)/boot/mkelf32 $(notes_phdrs) $(TARGET)-syms $(TMP) $(XEN_IMG_OFFSET) \
	               `$(NM) $(TARGET)-syms | sed -ne 's/^\([^ ]*\) . __2M_rwdata_end$$/0x\1/p'`
	od -t x4 -N 8192 $(TMP)  | grep 1badb002 > /dev/null || \
		{ echo "No Multiboot1 header found" >&2; false; }
	od -t x4 -N 32768 $(TMP) | grep e85250d6 > /dev/null || \
		{ echo "No Multiboot2 header found" >&2; false; }
	mv $(TMP) $(TARGET)

CFLAGS-$(XEN_BUILD_EFI) += -DXEN_BUILD_EFI

$(TARGET)-syms: $(objtree)/prelink.o $(obj)/xen.lds
	$(LD) $(XEN_LDFLAGS) -T $(obj)/xen.lds -N $< $(build_id_linker) \
	    $(objtree)/common/symbols-dummy.o -o $(@D)/.$(@F).0
	$(NM) -pa --format=sysv $(@D)/.$(@F).0 \
		| $(objtree)/tools/symbols $(all_symbols) --sysv --sort \
		>$(@D)/.$(@F).0.S
	$(MAKE) $(build)=$(@D) $(@D)/.$(@F).0.o
	$(LD) $(XEN_LDFLAGS) -T $(obj)/xen.lds -N $< $(build_id_linker) \
	    $(@D)/.$(@F).0.o -o $(@D)/.$(@F).1
	$(NM) -pa --format=sysv $(@D)/.$(@F).1 \
		| $(objtree)/tools/symbols $(all_symbols) --sysv --sort $(syms-warn-dup-y) \
		>$(@D)/.$(@F).1.S
	$(MAKE) $(build)=$(@D) $(@D)/.$(@F).1.o
	$(LD) $(XEN_LDFLAGS) -T $(obj)/xen.lds -N $< $(build_id_linker) \
	    $(orphan-handling-y) $(@D)/.$(@F).1.o -o $@
	$(NM) -pa --format=sysv $(@D)/$(@F) \
		| $(objtree)/tools/symbols --all-symbols --xensyms --sysv --sort \
		>$(@D)/$(@F).map
	rm -f $(@D)/.$(@F).[0-9]* $(@D)/..$(@F).[0-9]*
ifeq ($(CONFIG_XEN_IBT),y)
	$(SHELL) $(srctree)/tools/check-endbr.sh $@
endif

$(obj)/note.o: $(TARGET)-syms
	$(OBJCOPY) -O binary --only-section=.note.gnu.build-id $< $@.bin
	$(OBJCOPY) -I binary -O elf64-x86-64 -B i386:x86-64 \
		--rename-section=.data=.note.gnu.build-id -S $@.bin $@
	rm -f $@.bin

EFI_LDFLAGS += --image-base=$(1) --stack=0,0 --heap=0,0
EFI_LDFLAGS += --section-alignment=0x200000 --file-alignment=0x20
EFI_LDFLAGS += --major-image-version=$(XEN_VERSION)
EFI_LDFLAGS += --minor-image-version=$(XEN_SUBVERSION)
EFI_LDFLAGS += --major-os-version=2 --minor-os-version=0
EFI_LDFLAGS += --major-subsystem-version=2 --minor-subsystem-version=0
# It seems ld unfortunately can't set a custom timestamp, so add a zero value
# for the timestamp (option --no-insert-timestamp) if SOURCE_DATE_EPOCH is
# defined to make reproducible builds possible.
ifdef SOURCE_DATE_EPOCH
EFI_LDFLAGS += --no-insert-timestamp
endif

$(TARGET).efi: VIRT_BASE = 0x$(shell $(NM) $(obj)/efi/relocs-dummy.o | sed -n 's, A VIRT_START$$,,p')
ifeq ($(MKRELOC),:)
relocs-dummy :=
$(TARGET).efi: ALT_BASE :=
else
relocs-dummy := $(obj)/efi/relocs-dummy.o
$(TARGET).efi: ALT_BASE = 0x$(shell $(NM) $(obj)/efi/relocs-dummy.o | sed -n 's, A ALT_START$$,,p')
endif

ifneq ($(build_id_linker),)
ifeq ($(call ld-ver-build-id,$(LD) $(filter -m%,$(EFI_LDFLAGS))),y)
CFLAGS-y += -DBUILD_ID_EFI
EFI_LDFLAGS += $(build_id_linker)
note_file := $(obj)/efi/buildid.o
# NB: this must be the last input in the linker call, because inputs following
# the -b option will all be treated as being in the specified format.
note_file_option := -b pe-x86-64 $(note_file)
else
note_file := $(obj)/note.o
endif
else
note_file :=
endif
note_file_option ?= $(note_file)

extra-$(XEN_BUILD_PE) += efi.lds
ifeq ($(XEN_BUILD_PE),y)
$(TARGET).efi: $(objtree)/prelink.o $(note_file) $(obj)/efi.lds $(obj)/efi/relocs-dummy.o $(obj)/efi/mkreloc
ifeq ($(CONFIG_DEBUG_INFO),y)
	$(if $(filter --strip-debug,$(EFI_LDFLAGS)),echo,:) "Will strip debug info from $(@F)"
endif
	$(foreach base, $(VIRT_BASE) $(ALT_BASE), \
	          $(LD) $(call EFI_LDFLAGS,$(base)) -T $(obj)/efi.lds -N $< $(relocs-dummy) \
	                $(objtree)/common/symbols-dummy.o $(note_file_option) -o $(@D)/.$(@F).$(base).0 &&) :
	$(MKRELOC) $(foreach base,$(VIRT_BASE) $(ALT_BASE),$(@D)/.$(@F).$(base).0) >$(@D)/.$(@F).0r.S
	$(NM) -pa --format=sysv $(@D)/.$(@F).$(VIRT_BASE).0 \
		| $(objtree)/tools/symbols $(all_symbols) --sysv --sort >$(@D)/.$(@F).0s.S
	$(MAKE) $(build)=$(@D) .$(@F).0r.o .$(@F).0s.o
	$(foreach base, $(VIRT_BASE) $(ALT_BASE), \
	          $(LD) $(call EFI_LDFLAGS,$(base)) -T $(obj)/efi.lds -N $< \
	                $(@D)/.$(@F).0r.o $(@D)/.$(@F).0s.o $(note_file_option) -o $(@D)/.$(@F).$(base).1 &&) :
	$(MKRELOC) $(foreach base,$(VIRT_BASE) $(ALT_BASE),$(@D)/.$(@F).$(base).1) >$(@D)/.$(@F).1r.S
	$(NM) -pa --format=sysv $(@D)/.$(@F).$(VIRT_BASE).1 \
		| $(objtree)/tools/symbols $(all_symbols) --sysv --sort >$(@D)/.$(@F).1s.S
	$(MAKE) $(build)=$(@D) .$(@F).1r.o .$(@F).1s.o
	$(LD) $(call EFI_LDFLAGS,$(VIRT_BASE)) -T $(obj)/efi.lds -N $< \
	      $(@D)/.$(@F).1r.o $(@D)/.$(@F).1s.o $(orphan-handling-y) $(note_file_option) -o $@
	$(NM) -pa --format=sysv $(@D)/$(@F) \
		| $(objtree)/tools/symbols --all-symbols --xensyms --sysv --sort >$(@D)/$(@F).map
	rm -f $(@D)/.$(@F).[0-9]* $(@D)/..$(@F).[0-9]*
ifeq ($(CONFIG_XEN_IBT),y)
	$(SHELL) $(srctree)/tools/check-endbr.sh $@
endif
else
$(TARGET).efi: FORCE
	rm -f $@
	echo '$(if $(filter y,$(XEN_BUILD_EFI)),xen.efi generation,EFI support) disabled'
endif

# These should already have been rebuilt when building the prerequisite of "prelink.o"
$(obj)/efi/buildid.o $(obj)/efi/relocs-dummy.o: ;

.PHONY: include
include: $(objtree)/arch/x86/include/asm/asm-macros.h

$(obj)/asm-macros.i: CFLAGS-y += -P

$(objtree)/arch/x86/include/asm/asm-macros.h: $(obj)/asm-macros.i $(src)/Makefile
	$(call filechk,asm-macros.h)

define filechk_asm-macros.h
    echo '#if 0'; \
    echo '.if 0'; \
    echo '#endif'; \
    echo '#ifndef __ASM_MACROS_H__'; \
    echo '#define __ASM_MACROS_H__'; \
    echo 'asm ( ".include \"$@\"" );'; \
    echo '#endif /* __ASM_MACROS_H__ */'; \
    echo '#if 0'; \
    echo '.endif'; \
    cat $<; \
    echo '#endif'
endef

$(obj)/efi.lds: AFLAGS-y += -DEFI
$(obj)/xen.lds $(obj)/efi.lds: $(src)/xen.lds.S FORCE
	$(call if_changed_dep,cpp_lds_S)

clean-files := \
    include/asm/asm-macros.* \
    $(objtree)/.xen-syms.[0-9]* \
    $(objtree)/.xen.elf32 \
    $(objtree)/.xen.efi.[0-9]* \
    efi/*.efi

## xen 4.17.5+72-g01140da4e8

=== debian/changelog ===
xen (4.17.5+72-g01140da4e8-1) bookworm-security; urgency=medium

  Significant changes:
  * Update to new upstream version 4.17.5+72-g01140da4e8, which also contains
    security fixes for the following issues:
    (Closes: #1105193) (Closes: #1120075)
    - deadlock potential with VT-d and legacy PCI device pass-through
      XSA-467 CVE-2025-1713
    - x86: Indirect Target Selection
      XSA-469 CVE-2024-28956
    - x86: Incorrect stubs exception handling for flags recovery
      XSA-470 CVE-2025-27465
    - x86: Transitive Scheduler Attacks
      XSA-471 CVE-2024-36350 CVE-2024-36357
    - Multiple vulnerabilities in the Viridian interface
      XSA-472 CVE-2025-27466 CVE-2025-58142 CVE-2025-58143
    - Arm issues with page refcounting
      XSA-473 CVE-2025-58144 CVE-2025-58145
    - x86: Incorrect input sanitisation in Viridian hypercalls
      XSA-475 CVE-2025-58147 CVE-2025-58148
    - Incorrect removal of permissions on PCI device unplug
      XSA-476 CVE-2025-58149
  * Note that the following XSA are not listed, because...
     - XSA-468 applies to Windows PV drivers
     - XSA-474 applies to XAPI which is not included in Debian

  Packaging minor fixes and improvements:
  * debian/salsa-ci.yml: adjust for new salsa-ci pipeline

  Additional changes for 4.17 that were not backported upstream:
  * Cherry-pick dd05d265b8 ("x86/intel: Fix PERF_GLOBAL fixup when
    virtualised") to fix a boot loop when using Xen under nested
    virtualization (Closes: #1105222)

 -- Hans van Kranenburg <hans@knorrie.org>  Sat, 29 Nov 2025 14:52:25 +0100

## xen 4.18.5

=== debian/changelog ===
xen (4.18.5-1+deb12u3.1) bookworm; urgency=medium

  * HEAD @ 0b8f769d00bcfcda6
    update Xen version to 4.18.5-Thu 15 May 2025 01:07
  * XSA-469
    0079-x86-guest-Remove-use-of-the-Xen-hypercall_page.diff:This is part of XSA-469 / CVE-2024-28956
    0080-x86-thunk-Mis-align-__x86_indirect_thunk_-to-mitigate.diff:This is part of XSA-469 / CVE-2024-28956
    0081-x86-thunk-Mis-align-the-RETs-in-clear_bhb_loops-to-mi.diff:This is part of XSA-469 / CVE-2024-28956
    0082-x86-stubs-Introduce-place_ret-to-abstract-away-raw-0x.diff:This is part of XSA-469 / CVE-2024-28956
    0083-x86-thunk-Build-Xen-with-Return-Thunks.diff:This is part of XSA-469 / CVE-2024-28956
    0084-x86-spec-ctrl-Synthesise-ITS_NO-to-guests-on-unaffect.diff:This is part of XSA-469 / CVE-2024-28956
  * kconfig: rebase as d/xen_4.18_amd64.config

 -- Mark Pryor <pryorm09@gmail.com>  Fri, 16 May 2025 17:32:48 -0700

xen (4.18.4-1+deb12u3.2) bookworm; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 746df32732dcdb51
    IOMMU/x86: the bus-to-bridge lock needs to be acquired IRQ-safe-Thu 27 Feb 2025 06:00
  * XSA-467
    0027-IOMMU-x86-the-bus-to-bridge-lock-needs-to-be-acquired.diff:This is XSA-467 / CVE-2025-1713

 -- Mark Pryor <pryorm09@gmail.com>  Mon, 10 Mar 2025 13:39:25 -0700

xen (4.18.4-1+deb12u3.1) bookworm; urgency=medium

  * HEAD @ e77ff547385861c
    update Xen version to 4.18.4-Thu 19 Dec 2024 00:04
  * qemuu: v8.05
  * initial build of xen-4.18.4
  * XSA-463
    0045-x86-HVM-drop-stdvga-s-cache-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
    0046-x86-HVM-drop-stdvga-s-stdvga-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
    0047-x86-HVM-remove-unused-MMIO-handling-code.diff:This is part of XSA-463 / CVE-2024-45818
    0048-x86-HVM-drop-stdvga-s-gr-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
    0049-x86-HVM-drop-stdvga-s-sr-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
    0050-x86-HVM-drop-stdvga-s-g-s-r_index-struct-members.diff:This is part of XSA-463 / CVE-2024-45818
    0051-x86-HVM-drop-stdvga-s-vram_page-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
    0052-x86-HVM-drop-stdvga-s-lock-struct-member.diff:This is part of XSA-463 / CVE-2024-45818
  * XSA-464
    0054-libxl-Use-zero-ed-memory-for-PVH-acpi-tables.diff:This is XSA-464 / CVE-2024-45819.

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 19 Dec 2024 17:05:39 -0800

xen (4.18.3-1+deb12u3.3) bookworm; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 2b18f341cb5c66b
    x86/boot: Fix XSM module handling during PVH boot-Tue 29 Oct 2024 08:42

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 31 Oct 2024 08:29:36 -0700

xen (4.18.3-1+deb12u3.2) bookworm; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 2c5f888204d988110
    xen/ucode: Fix buffer under-run when parsing AMD containers-Tue 24 Sep 2024 06:0
  * XSA-462
    0004-x86-vLAPIC-prevent-undue-recursion-of-vlapic_error.diff:This is XSA-462 / CVE-2024-45817.

 -- Mark Pryor <pryorm09@gmail.com>  Wed, 25 Sep 2024 08:05:34 -0700

xen (4.18.3-1+deb12u3.1) bookworm; urgency=medium

  * HEAD @ bd51e573a730efc569646
    update Xen version to 4.18.3-Wed 14 Aug 2024 06:45:06
  * initial build of 4.18.3
  * XSA-458
    0053-x86-IRQ-avoid-double-unlock-in-map_domain_pirq.patch:This is CVE-2024-31143 / XSA-458.
  * XSA-460
    0065-x86-IOMMU-move-tracking-in-iommu_identity_mapping.patch:This is XSA-460 / CVE-2024-31145.
  * XSA-461
    0066-x86-pass-through-documents-as-security-unsupported-w.patch:This is XSA-461 / CVE-2024-31146.
 
 -- Mark Pryor <pryorm09@gmail.com>  Fri, 16 Aug 2024 08:40:47 -0700

xen (4.18.2-1+deb12u3.4) bookworm; urgency=medium

  * Non-maintainer upload.
  * fully leaf libxenmisc* to 4.18
    libs.mk: revert to 4.17

 -- Mark Pryor <pryorm09@gmail.com>  Mon, 22 Jul 2024 09:45:09 -0700

xen (4.18.2-1+deb12u3.3) bookworm; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 45c5333935628e7c80d
    evtchn: build fix for Arm-Thu 4 Jul 2024 07:57

 -- Mark Pryor <pryorm09@gmail.com>  Sun, 21 Jul 2024 12:31:49 -0700

xen (4.18.2-1+deb12u3.2) bookworm; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 01f7a3c792241d348a4
    update Xen version to 4.18.3-pre-Tue 21 May 2024 02:52

 -- Mark Pryor <pryorm09@gmail.com>  Fri, 24 May 2024 10:51:40 -0700

xen (4.18.2-1+deb12u3.1) bookworm; urgency=medium

  * HEAD @ b2863e468e8119664be6
    Update Xen version to 4.18.2-Tue 9 Apr 2024 08:45
  * XSA-454
    0015-x86-HVM-clear-upper-halves-of-GPRs-upon-entry-from-32.diff:This is part of XSA-454 / CVE-2023-46842.
    0016-hypercall_xlat_continuation-Replace-BUG_ON-with-domai.diff:This is part of XSA-454 / CVE-2023-46842.
  * XSA-455
    0017-x86-spec-ctrl-Fix-BTC-SRSO-mitigations.diff:This is XSA-455 / CVE-2024-31142.
    0038-x86-spec-ctrl-Rename-spec_ctrl_flags-to-scf.diff:XSA-455 was ultimately caused by having fields with too-similar names.
    0046-x86-Use-indirect-calls-in-reset-stack-infrastructure.diff:Luckily due to XSA-348, all C target functions of reset_stack_and_jump_ind()
  * XSA-456
    0046-x86-Use-indirect-calls-in-reset-stack-infrastructure.diff:This is part of XSA-456 / CVE-2024-2201.
    0047-x86-Drop-INDIRECT_JMP.diff:This is part of XSA-456 / CVE-2024-2201.
    0048-x86-tsx-Expose-RTM_ALWAYS_ABORT-to-guests.diff:This is part of XSA-456 / CVE-2024-2201.
    0049-x86-spec-ctrl-Support-BHI_DIS_S-in-order-to-mitigate-.diff:This is part of XSA-456 / CVE-2024-2201.
    0050-x86-spec-ctrl-Software-BHB-clearing-sequences.diff:This is part of XSA-456 / CVE-2024-2201.
    0051-x86-spec-ctrl-Wire-up-the-Native-BHI-software-sequenc.diff:This is part of XSA-456 / CVE-2024-2201.
    0052-x86-spec-ctrl-Support-the-long-BHB-loop-sequence.diff:This is part of XSA-456 / CVE-2024-2201.

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 11 Apr 2024 09:42:10 -0700

xen (4.18.1-1+deb12u3.2) bookworm; urgency=medium

  * Non-maintainer upload.
  * rebuild for nmu



=== debian/control ===
Source: xen
Section: kernel
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Guido Trotter <ultrotter@debian.org>, Bastian Blank <waldi@debian.org>, Ian Jackson <ian.jackson@eu.citrix.com>
Standards-Version: 4.5.0
Build-Depends: autotools-dev, debhelper (>> 10), dpkg-dev (>= 1.16.0~), lsb-release, python3-dev, python3-lxml, pandoc, bison, flex, bcc [i386 amd64], gcc-multilib [i386 amd64], e2fslibs-dev, iasl, seabios (>= 1.7.4-2~) [i386 amd64], libaio-dev, libfdt-dev [armhf arm64 amd64], libglib2.0-dev, liblzma-dev, libncurses5-dev, libpixman-1-dev, libyajl-dev, pkg-config, uuid-dev, zlib1g-dev, libfile-fcntllock-perl, dh-python, dh-strip-nondeterminism, dh-buildinfo, libsystemd-dev, figlet, libnl-3-dev, libnl-route-3-200, libnl-route-3-dev, checkpolicy, libnuma-dev, ghostscript, libbz2-dev, device-tree-compiler, texinfo, python3-markdown, texi2html, fig2dev, liblz4-dev, acpica-tools <!noqemu>, libaio-dev [linux-any] <!noqemu>, libasound2-dev [linux-any] <!noqemu>, libattr1-dev <!noqemu>, libbrlapi-dev <!noqemu>, ninja-build <!noqemu>, meson <!noqemu>, libfuse3-dev <!noqemu>, libkeyutils-dev <!noqemu>, libcapstone-dev <!noqemu>, libzstd-dev <!noqemu>, libglusterfs-dev <!noqemu>, libiscsi-dev <!noqemu>, libvirglrenderer-dev <!noqemu>, libslirp-dev <!noqemu>, slirp <!noqemu>, libcap-dev [linux-any] <!noqemu>, libcap-ng-dev [linux-any] <!noqemu>, libcurl4-gnutls-dev <!noqemu>,
  liburing-dev [linux-any] <!noqemu>, libibverbs-dev <!noqemu>,libibumad-dev <!noqemu>,libfabric-dev <!noqemu>,
  libepoxy-dev <!noqemu>, libgbm-dev <!noqemu>, libdbus-1-dev  <!noqemu>, dbus-daemon, libpam0g-dev <!noqemu>,
  git, wget,
  librdmacm-dev  <!noqemu>,
  libfdt-dev [armhf arm64 amd64]  <!noqemu>,
  gnutls-dev <!noqemu>,
  libiscsi-dev (>> 1.9.0~) <!noqemu>,
  libncursesw5-dev  <!noqemu>, libncurses5-dev <!noqemu>,
  libnfs-dev (>> 1.9.3) <!noqemu>,
  libnuma-dev [i386 amd64 ia64 mips mipsel powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc hppa] <!noqemu>,
  libcacard-dev <!noqemu>,
  libpulse-dev <!noqemu>,
  librados-dev [linux-any]  <!noqemu>, librbd-dev [linux-any] <!noqemu>,
  libsasl2-dev <!noqemu>,
  libsdl2-dev <!noqemu>, libsdl2-image-dev <!noqemu>,
  libseccomp-dev (>> 2.1.0) [linux-amd64 linux-i386] <!noqemu>,
  libspice-server-dev (>= 0.12.2~) [linux-amd64 linux-i386] <!noqemu>,
  libspice-protocol-dev (>= 0.12.3~) [linux-amd64 linux-i386] <!noqemu>,
  libusb-1.0-0-dev (>= 2:1.0.13~) [linux-any] <!noqemu>,
  libusbredirparser-dev (>= 0.6~) [linux-any] <!noqemu>,
  libssh-dev <!noqemu>,
  libvdeplug-dev <!noqemu>,
  libx11-dev <!noqemu>,
  uuid-dev <!noqemu>,
  xfslibs-dev [linux-any] <!noqemu>,
  zlib1g-dev <!noqemu>,
  libjpeg-dev <!noqemu>,
  libpng-dev <!noqemu>,
  libpci3 <!noqemu>,
  libbpf-dev <!noqemu>,
  python3-sphinx-rtd-theme <!noqemu>, python3-sphinx <!noqemu>,
  python3-venv <!noqemu>,
  liblzo2-2  <!noqemu>,liblzo2-dev  <!noqemu>,
  libsdl1.2debian  <!noqemu>, libsdl1.2-dev  <!noqemu>, ipxe-qemu  <!noqemu>,
XS-Python-Version: 3.9, 3.10, 3.11
XS-X-Python3-Version: >= 3.11

Package: libxenmisc4.18
Architecture: amd64 arm64 armhf i386
Section: libs
Replaces: libxen-4.18
Breaks: libxen-4.18 (<< ${source:Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Public libs for Xen
 This package contains the shared toolstack libraries for Xen.
Multi-Arch: same

Package: libxenstore4.0
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libxentoolcore1 (= ${binary:Version})
Description: Xenstore communications library for Xen
 This package contains the client library interface to XenStore.  .
Multi-Arch: same

Package: libxentoolcore1
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: helper for qemu & libxenstore
 This package contains a depends to XenStore.  .
Multi-Arch: same

Package: libxenfsutl4.18
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: xen-utils-4.18 companion libs
 This package contains a depends to XenStore.  .
Multi-Arch: same

Package: libxen-dev
Architecture: amd64 arm64 armhf i386
Section: libdevel
Depends: libxenmisc4.18 (= ${binary:Version}), libxenstore4.0 (= ${binary:Version}), ${misc:Depends}
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with the
 XenStore database.  XenStore is a shared database used for interdomain
 communication of configuration and status information.  It is accessible
 to all domains running on the same Xen host.  See
 http://wiki.xen.org/wiki/XenStore for more information.
 .
 The libxenctrl and libxenguest libraries are internal libraries intended
 for use by the Xen toolstack and are not intended to be used directly.
 Toolstack authors should use libxenlight.
Multi-Arch: same

Package: xenstore-utils
Architecture: amd64 arm64 armhf i386
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 3.1.0-1)
Conflicts: xen-utils-common (<= 3.1.0-1)
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See http://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Architecture: all
Depends: lsb-base, python3, udev, xenstore-utils, ${misc:Depends}
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-utils-4.18
Architecture: amd64 arm64 armhf i386
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, xen-utils-common (>= ${source:Version}), libxenfsutl4.18 (>= ${source:Version})
Recommends: bridge-utils, libc6-xen [i386], xen-hypervisor-4.18, qemuu
Suggests: seabios [i386 amd64], grub-xen-host [i386 amd64]
Description: XEN administrative tools
 The userspace tools to manage a system virtualized through the XEN virtual
 machine monitor.
 .
 qemu-utils and seabios are neded for "Xen HVM" (amd64 and i386)
Built-Using: ${misc:Built-Using}

Package: qemuu
Architecture: amd64 arm64 armhf i386
Section: admin
Provides: qemu-system-i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: qemu-system-i386 (8.0.5/xen-4.18) with 9pfs support
 Warning: This is a custom testing build of Xen.
Build-Profiles: <!noqemu>
Installed-Size: $(du -ks deb | cut -f1)

Package: qemut
Architecture: amd64 arm64 armhf i386
Section: admin
Provides: qemu-dm
Depends: ${shlibs:Depends}, ${misc:Depends}, ipxe-qemu
Description: qemu-dm (0.10.2/xen-4.18) with 9pfs support
 Warning: This is a custom testing build of Xen.
Build-Profiles: <!noqemu>
Installed-Size: $(du -ks deb | cut -f1)

Package: qemuu-uncom
Architecture: amd64 arm64 armhf i386
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: qemuu
Description: Circular depends for qemu-keymap used to build qemuu
 This package contains only /usr/bin/qemu-keymap.

Package: xen-hypervisor-4.18-amd64
Architecture: amd64 i386
Provides: xen-hypervisor, xen-hypervisor-4.18, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.18
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-amd64
Architecture: amd64 i386
Provides: xen-system
Depends: xen-hypervisor-4.18-amd64, xen-utils-4.18, ${misc:Depends}
Description: Xen System on AMD64 (meta-package)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.18-arm64
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.18, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.18
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-arm64
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.18-arm64, xen-utils-4.18, ${misc:Depends}
Description: Xen System on ARM64 (meta-package)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: xen-hypervisor-4.18-armhf
Architecture: armhf
Provides: xen-hypervisor, xen-hypervisor-4.18, xen-hypervisor-armhf
Depends: ${misc:Depends}
Recommends: xen-utils-4.18
Description: Xen Hypervisor on ARMHF
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-armhf
Architecture: armhf
Provides: xen-system
Depends: xen-hypervisor-4.18-armhf, xen-utils-4.18, ${misc:Depends}
Description: Xen System on ARMHF (meta-package)
 This package depends on the latest Xen hypervisor for use on ARMHF and the
 Xen utils.
